main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.story7, name='story7'),
]

ppw_after_uts/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('', include('story8.urls')),
    path('', include('story9.urls')),
]

story8/urls.py
from django.urls import path
from . import views


urlpatterns = [
   path('books/', views.index, name = 'books'),
   path('data/', views.data, name = 'data'),
]

story9/urls.py
from django.urls import path
from . import views

urlpatterns = [
   path('signup/', views.signUp, name = 'signup'),
   path('login/', views.login_view, name = 'login'),
   path('logout/', views.logout_view, name = 'logout'),
]

main/models.py
from django.db import models

# Create your models here.

story8/models.py
from django.db import models

# Create your models here.

story9/models.py
from django.db import models

# Create your models here.

story9/forms.py
from django import forms
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm

class SignUpForm(UserCreationForm):
    username = forms.CharField(
        label="Username",
        widget=forms.TextInput(
            attrs={
                'class': 'form-control',
                'type' : 'text',
                'placeholder': 'Enter your username',
                'name': 'username',
            }
        ),
        max_length=16
    )

    email = forms.EmailField(
        label="Email",
        widget=forms.EmailInput(
            attrs={
                'class': 'form-control',
                'type' : 'email',
                'placeholder': 'Enter your email',
                'name': 'email',
            }
        )
    )

    password1 = forms.CharField(
        label="Password",
        widget=forms.PasswordInput(
            attrs={
                'class': 'form-control',
                'type' : 'password',
                'placeholder': 'Enter your password',
                'name': 'password',
            }
        )
    )

    password2 = forms.CharField(
        label="Password Confirmation",
        widget=forms.PasswordInput(
            attrs={
                'class': 'form-control',
                'type' : 'password',
                'placeholder': 'Confirm your password',
                'name': 'password',
            }
        )
    )

class LoginForm(AuthenticationForm):
    username = forms.CharField(label="Username", 
    widget=forms.TextInput(
        attrs={
        'class' : 'form-control',
        'placeholder' : 'Username',
        'type' : 'text',
        'name': 'username',
    }))

    password = forms.CharField(label="Password", 
    widget=forms.PasswordInput(
        attrs={
        'class' : 'form-control',
        'placeholder' : 'Password',
        'type' : 'password',
        'name': 'password',
    }))

main/views.py
from django.shortcuts import render


def story7(request):
    return render(request, 'main/story7.html')

story8/views.py
from django.shortcuts import render
from django.http import JsonResponse
import json
import requests

def index(request):
    response = {}
    return render(request,'story8/books.html',response)

def data(request):
    url = "https://www.googleapis.com/books/v1/volumes?q=" + request.GET['q']
    data = requests.get(url).json()
    return JsonResponse(data)

story9/views.py
from django.shortcuts import render, redirect
from .forms import LoginForm, SignUpForm
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.decorators import login_required
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm
from django.contrib import messages

def signUp(request):
    
    if request.method == 'POST':
        form = SignUpForm(request.POST)

        if form.is_valid():
            user = form.save()
            login(request, user)
            return redirect("login")

        else:
            for msg in form.error_messages:
                messages.error(request, 'Invalid entry')

    else:
        form = SignUpForm()

    context = {
        'form' : form
    }

    return render(request, "story9/signup.html", context)

def login_view(request):
    
    if request.method == "POST":
        form = LoginForm(data = request.POST)

        if form.is_valid():
            usernameInput = request.POST["username"]
            passwordInput = request.POST["password"]

            user = authenticate(request, username = usernameInput, password = passwordInput)

            if user is not None:
                login(request, user)
                return redirect('login')

        else:
            messages.error(request, 'Invalid entry')

    else:
        form = LoginForm()

    context = {
        "form" : form,
    }

    return render(request, "story9/login.html", context)



@login_required
def logout_view(request):
    logout(request)
    form = LoginForm()
    response = {'form':form}
    return redirect ('login')

main/templates/main/story7.html
{% extends 'base.html' %}
{%load static%}

{% block content %}
    <br>
    <h1 style="text-align : center"> MY INFORMATION </h1>
    <br>
    <br>
  <div class="container-fluid">

    <div class="box">
        <div class="accordion">Aktivitas 
            <div class="move">
              <div class="move-down" id="down">&#x2B07;</div>
              <div class="move-up" id="up">&#x2B06;</div>
            </div>
        </div>
        
        <div class="panel">
          <p>Mahasiswi Universitas Indonesia</p>
        </div>
    </div>

    <div class="box">
        <div class="accordion">Pengalaman Organisasi/Kepanitiaan
            <div class="move">
              <div class="move-down">&#x2B07;</div>
              <div class="move-up">&#x2B06;</div>
            </div>
        </div>
        <div class="panel"> 
          <li>Wakil Ketua OSIS 2 SMAN 46 Jakarta</li>
          <li>Ketua OSIS SMAN 46 Jakarta</li>
          <li>Staff Sponsorship Pentas Seni SMAN 46 Jakarta</li>  
        </div>
    </div>

    <div class="box">
        <div class="accordion">Prestasi
            <div class="move">
              <div class="move-down">&#x2B07;</div>
              <div class="move-up">&#x2B06;</div>
            </div>
        </div>
        <div class="panel">
            <p>Masih dalam pencarian</p>
        </div>
    </div>

    <div class="box">
        <div class="accordion">Minat dan Hobi
            <div class="move">
              <div class="move-down" id="down1">&#x2B07;</div>
              <div class="move-up" id="up1">&#x2B06;</div>
            </div>
        </div>
        <div class="panel">
          <li>Memasak makanan terutama hidangan western</li>
          <li>Menyanyi</li>
          <li>Bisnis</li> 
        </div>
    </div>

  </div>
{% endblock %}

{% block script %}
  <script src="{% static 'js/story7.js' %}"></script>
{% endblock %}



        

story8/templates/story8/books.html
{% extends 'base.html'%}
{% load static %}

{% block content %}

<div class="container-fluid">
    <div class = "row">
        <div class="col-sm-12">
            <h2 class="text-center"> DAFTAR BUKU </h2>
            <br>
            <br>

            <div class="input">
            <input type="text" class="form-control rounded-pill" id="input" placeholder="Search for books.." title="Type in a name">
            </div>
            <br>
            <br>
            <div class="table-responsive-md">
                <table id="list_buku" class="table table-striped">

                    <thead style="background-color:#222159;">
                        <tr style="color:#FFFFFF">
                            <th scope="col" class="align-middle">No</th>
                            <th scope="col" class="align-middle">Cover</th>
                            <th scope="col" class="align-middle">Title</th>
                            <th scope="col" class="align-middle">Authors</th>
                            <th scope="col" class="align-middle">Publisher</th>
                            <th scope="col" class="align-middle">Published Date</th>
                        </tr>
                    </thead>

                    <tbody id="isi">
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
{% endblock %}

{% block script %}
  <script src="{% static 'js/story8.js' %}"></script>
{% endblock %}

story9/templates/story9/login.html
{% extends 'base.html' %}
{% load static %}

{% block content %}

{% if user.is_authenticated %} 
<div class="container-fluid">
    <div class = "row">
        <div class="col-sm-12">
            <h2> Welcome, <strong>{{user.username}}</strong> </h2>
            <br>
            <br>
            <div class="tombol">
                <a style= "background-color: #232065" class="btn btn-primary btn-lg" href="{% url 'logout' %}">Logout</a>
            </div>
        </div>
    </div>
</div>

{% else %}
<div class="container-fluid">
    <div class = "row">
        <div class="col-sm-12">
            <h2 class="text-center"> Hey, let's login first! </h2>
            <br>
            <br>
            <form class="align-self-center" action="" method="POST">
                {% csrf_token %}
                {{ form }}
                <br>
                <button style= "background-color: #232065" type="submit" class="btn btn-primary btn-lg">Login</button>
            </form>

            <div class="info mt-5">
                <p>
                    Don't have an account? <a class="sign-up-in-link" href="{% url 'signup' %}"><strong>Sign up.</strong></a>
                </p>
            </div>

        </div>
    </div>
</div>
{% endif %}

{% endblock %}

story9/templates/story9/signup.html
{% extends 'base.html' %}
{% load static %}

{% block content %}

<div class="container-fluid">
    <div class = "row">
        <div class="col-sm-12">
            <h2 class="text-center"> Sign-Up Your Account </h2>
            <br>
            <br>
            <form class=" align-self-center" action="" method="POST">
                {% csrf_token %}
                {{ form }}
                <br>
                <button style= "background-color: #232065" type="submit" class="btn btn-primary btn-lg">Sign Up</button>
            </form>

            <div class="info mt-5">
                <p>
                    Have account already? <a class="sign-up-in-link" href="{% url 'login' %}"><strong>Log in.</strong></a>
                </p>
            </div>

        </div>
    </div>
</div>

{% endblock %}

templates/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">


<head>
  <title>Story 7</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" 
  href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" 
  integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" 
  crossorigin="anonymous">
  <link rel="stylesheet" href="{% static 'css/style.css' %}"/>
</head>

<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">

        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#menu" aria-controls="navbarTogglerDemo02" aria-expanded="true" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="menu">
            <ul class="navbar-nav mr-auto mt-2 mt-lg-0">
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'main:story7' %}">Information</a>
                    <a class="nav-link" href="{% url 'books' %}">Books</a>
                    <a class="nav-link" href="{% url 'login' %}">Story 9</a>
                </li>
            </ul>
        </div>
    </nav>
    <br>
    {% block content %}
    {% endblock %}
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    {% block script %}
    {% endblock %}
</body>
<html>